#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "dinotail.inc"
#include "dinobody.inc"
#include "dinonck.inc"
#include "dinorlg1.inc"
#include "dinorlg2.inc"
#include "dinoflg1.inc"
#include "dinoflg2.inc"
#include "dinohead.inc"

camera {
  location  <0 -20 -140> 
  direction <0 0 1.5>
  up        <0 1 0>
  right     <1.33 0 0>
  look_at   <0 16 2> 
}

object { light_source { <60 100 -130> color White } }

#declare Eyeball = 
  union {
    quadric {
      Ellipsoid
      texture {
        color White
        specular 1.0
        roughness .001
      }
      scale <1 .45 1>
      rotate <-90 0 0>
    }
    quadric {
      Ellipsoid
      texture {
        color Black
        specular 1.0
        roughness .001
      }
      scale <.66 .3 .66>
      rotate <-90 0 0>
      translate <0 0 -.45>
    }
  }

#declare Brachiosaurus1 =
  composite {
    composite {
      DinoTail
      translate <-33 -17.5 0>
    }
    composite {
      DinoBody
      scale <1.15 1 1>
      rotate <0 0 -6>
      translate <13 -10 0>
    }
    composite {
      DinoNeck
      scale <1.1 1 1>
      translate <34.5 15 0>
    }
    composite {
      DinoHead
      scale <.6 .5 .5>
      translate <36 34.5 0>
      clipped_by {
        quadric {
          Ellipsoid
          scale <.35 1.5 1>
          rotate <0 0 -107>
          translate <35 35 0>
          inverse
        }
      }
      clipped_by {
        quadric {
          Ellipsoid
          scale <.35 1.75 1>
          rotate <0 0 -115>
          translate <34.5 34.55 0>
          inverse
        }
      }
    }
    object {
      quadric {
        Ellipsoid
        rotate <0 0 -75>
        scale <2.25 1 1>
        translate <31.5 37 0>
      }
      texture {
        color DarkSlateGray
      }
    }
    object {
      union {
        Eyeball
        scale <.5 .5 .25>
        rotate <0 -10 0>
        translate <33 36.75 -1>
      }
    }
    object {
      union {
        Eyeball
        rotate <0 180 0>
        scale <.5 .5 .25>
        rotate <0 10 0>
        translate <33 36.75 1>
      }
    }
    composite {
      DinoRearLeg1
      scale <1.85 1.5 1>
      rotate <-10 0 15>
      translate <-7 -17 -4>
    }
    composite { 
      DinoRearLeg2
      scale <1.85 1.5 1>
      rotate <-5 -15 -15>
      translate <-8 -17 4.5>
    }
    composite {
      DinoFrontLeg1
      scale <1.85 1.5 1>
      rotate <0 0 0>
      translate <18 -15 4.5>
    }
    composite {
      DinoFrontLeg2
      scale <1.85 1.5 1>
      rotate <0 0 12>
      translate <18 -15 -4.25>
    }
  }


#declare Brachiosaurus2 =
  composite {
    composite {
      DinoTail
      rotate <180 0 20>
      translate <-35 -16 0>
    }
    composite {
      DinoBody
      scale <1.15 1 1>
      rotate <0 0 -6>
      translate <13 -10 0>
    }
    composite {
      DinoNeck
      scale <1.1 1 1>
      translate <34.5 15 0>
    }
    composite {
      DinoHead
      scale <.6 .5 .5>
      translate <36 34.5 0>
      clipped_by {
        quadric {
          Ellipsoid
          scale <.35 1.5 1>
          rotate <0 0 -107>
          translate <35 35 0>
          inverse
        }
      }
      clipped_by {
        quadric {
          Ellipsoid
          scale <.35 1.75 1>
          rotate <0 0 -115>
          translate <34.5 34.55 0>
          inverse
        }
      }
    }
    object {
      quadric {
        Ellipsoid
        rotate <0 0 -75>
        scale <2.25 1 1>
        translate <31.5 37 0>
      }
      texture {color DarkSlateGray}
    }
    object {
      union {
        Eyeball
        scale <.5 .5 .25>
        rotate <0 -10 0>
        translate <33 36.75 -1>
      }
    }
    object {
      union {
        Eyeball
        rotate <0 180 0>
        scale <.5 .5 .25>
        rotate <0 10 0>
        translate <33 36.75 1>
      }
    }
    composite {  
      DinoRearLeg1  
      scale <1.85 1.5 1>
      rotate <-5 -15 15>
      translate <-7 -17 4>
    }
    composite {
      DinoRearLeg2
      scale <1.85 1.5 1>
      rotate <10 0 -15>
      translate <-8 -17 -4.25>
    }
    composite {
      DinoFrontLeg1
      scale <1.85 1.5 1>
      rotate <0 0 0>
      translate <18 -15 -4>
    }
    composite {
      DinoFrontLeg2
      scale <1.85 1.5 1>
      rotate <0 0 12>
      translate <18 -15 4.25>
    }
  }


composite {
  Brachiosaurus2
  rotate <0 125 0>
  translate <30 0 10>
}


composite {
  Brachiosaurus1
  rotate <0 125 0>
  translate <-10 0 -10>
}


object {
  sphere {<0 -524 -30> 500}
  texture {
    color red 0.45 green 0.35 blue 0.15
    bump_map {gif "plasma7.gif" map_type 1 bump_size 5 interpolate 2}
    scale <1 1 1>
  }
}


object {
  sphere {<0 0 0> 10000}
  texture {
    gradient <0 1 0>
    color_map {
      [0.0 0.5 color red 1.0 green 0.3 blue 0.0
               color red 0.7 green 0.7 blue 1.0]
      [0.5 1.0 color red 0.7 green 0.7 blue 1.0
               color red 0.7 green 0.7 blue 1.0]
    }
    scale <10000 10000 10000>
    translate <0 1500 0>
    ambient 1.0
    diffuse 0.0
  }
}


object {
  sphere {<0 0 0> 9000}
    texture {
      wood
      turbulence 0.5
      color_map {
        [0.0 0.3 color red 1.0 green 1.0 blue 1.0 alpha 1.0
                 color red 1.0 green 1.0 blue 1.0 alpha 1.0]
        [0.3 0.8 color red 1.0 green 1.0 blue 1.0 alpha 1.0
                 color red 1.0 green 1.0 blue 1.0 alpha 0.7]
        [0.8 1.0 color red 1.0 green 1.0 blue 1.0 alpha 0.7
                 color red 0.9 green 0.9 blue 0.9 alpha 0.5]
      }
      scale <10000 1000 3000>
      rotate <0 0 12>
      ambient 0.7 
      diffuse 0.0
    }
    color red 0.7 green 0.7 blue 0.7
}


object {
  height_field {gif "plasma6.gif" }
  translate <-.2 -.5 0>
  scale <3 2 1>
  texture {
    color DarkSlateGray
    ambient 0.1
    diffuse 0.3
  }
    scale <500 150 150>
    translate <0 -50 500>
}